@ECHO OFF
SETLOCAL
IF NOT "%1"=="internal" (
	PUSHD "%~dp0.."
)

SET scannerDir=.\
SET logfile="%scannerDir%\logs\run_hw.log"
CALL "%scannerDir%bin\tools.bat" GetCurrentDate currentDate
CALL "%scannerDir%bin\tools.bat" GetCurrentTime currentTime
CALL "%scannerDir%bin\tools.bat" GetCurrentUNIXtimestamp currentUNIXTimestamp
SET currentTimestamp=%currentDate%_%currentTime%

CALL "%scannerDir%bin\tools.bat" Log "Starting run_hw.bat (windows 9.2.16.0-20190827-1723)"

CALL "%scannerDir%bin\tools.bat" Log "Running command: %scannerDir%cit\bin\wscanhw.exe -nolock -s -c %scannerDir%config\tlm_hw_config.xml -o %scannerDir%work\archive\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml"
ECHO Starting hardware scan
"%scannerDir%cit\bin\wscanhw.exe" -nolock -s -c "%scannerDir%config\tlm_hw_config.xml" -o "%scannerDir%work\archive\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml"
SET rc=%ERRORLEVEL%
IF %rc% NEQ 0 (
	CALL "%scannerDir%bin\tools.bat" Log "Hardware scan finished with return code: %rc%"
	ECHO Hardware scan finished with return code: %rc%
	IF NOT "%1"=="internal" (
		POPD
	)
	ENDLOCAL
	EXIT /B %rc% 
	)

IF EXIST "%scannerDir%work\tlm_hw_last.xml" (
		CALL "%scannerDir%bin\tools.bat" Log "Running command: FC /B %scannerDir%work\tlm_hw_last.xml %scannerDir%work\archive\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml"
		ECHO Comparing hardwarew scan output with the previous one
		FC /B "%scannerDir%work\tlm_hw_last.xml" "%scannerDir%work\archive\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml" 2>NUL 1>NUL
		:: ERRORLEVEL has to be checked this way, because it's in parentheses
		IF NOT ERRORLEVEL 1 (
			CALL "%scannerDir%bin\tools.bat" Log "FC returned 0 - files are identical" 
			ECHO Hardware scan output identical to the previous one - update not required
			CALL "%scannerDir%bin\tools.bat" Log "run_hw.bat ended"
			ECHO Hardware scan finished
			IF NOT "%1"=="internal" (
				POPD
			)
			ENDLOCAL
			EXIT /B 0
		) ELSE (
			CALL "%scannerDir%bin\tools.bat" Log "FC returned 1 - files not identical" 
			ECHO Hardware scan output changed - update required 
		)
	) ELSE (
		CALL "%scannerDir%bin\tools.bat" Log "%scannerDir%work\tlm_hw_last.xml does not exist"
	)

:: This part is to be executed only in case of initial run or change in hardware scan results
CALL "%scannerDir%bin\tools.bat" Log "Running command: COPY /Y /V %scannerDir%work\archive\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml %scannerDir%work\tlm_hw_last.xml 2>NUL 1>NUL"
COPY /Y /V "%scannerDir%work\archive\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml" "%scannerDir%work\tlm_hw_last.xml" 2>NUL 1>NUL

CALL "%scannerDir%bin\tools.bat" Log "Running command: ECHO tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml > %scannerDir%work\tlm_hw_last.filename"
ECHO tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml > "%scannerDir%work\tlm_hw_last.filename"

CALL "%scannerDir%bin\tools.bat" Log "Running command: COPY /Y /V %scannerDir%work\archive\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml %scannerDir%work\hw_scans_unique\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml 2>NUL 1>NUL"
COPY /Y /V "%scannerDir%work\archive\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml" "%scannerDir%work\hw_scans_unique\tlm_hw_%currentDate%%currentTime%_%currentUNIXTimestamp%.xml" 2>NUL 1>NUL

CALL "%scannerDir%bin\tools.bat" Log "run_hw.bat ended"
ECHO Hardware scan finished
IF NOT "%1"=="internal" (
	POPD
)
ENDLOCAL & EXIT /B 0