@ECHO OFF

CALL:%1 %2
EXIT /B %ERRORLEVEL%

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GetCurrentTime currentTime
:: Extracting current time in hhmmss format from wmic output - must be locale/user setting independent
SETLOCAL
FOR /F %%x IN ('wmic os get localdatetime ^| FINDSTR /B [0-9]') DO SET ct=%%x
ENDLOCAL & SET %1=%ct:~8,6%
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GetCurrentTimeHHMM currentTimeHHMM
:: Extracting current time in hhmmss format from %TIME% variable
SETLOCAL
FOR /F %%x IN ('wmic os get localdatetime ^| FINDSTR /B [0-9]') DO SET ct=%%x
ENDLOCAL & SET %1=%ct:~8,4%
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GetCurrentDate currentDate
:: Extracting current date in YYYYMMDD format from %DATE% variable
SETLOCAL
FOR /F %%x IN ('wmic os get localdatetime ^| FINDSTR /B [0-9]') DO set cd=%%x
ENDLOCAL & SET %1=%cd:~0,8%
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GetShortPath shortPath
:: Returns short version of a given path
SETLOCAL
for %%I in ("%longPath%") do SET p=%%~sI
ENDLOCAL & SET %1=%p%
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GetCurrentUNIXtimestamp currentUNIXTimestamp
:: Calculating UNIX timestamp by counting seconds from 1970-01-01 till current UTC time
FOR /F %%x IN ('wmic path win32_utctime get /format:list ^| findstr "="') DO (SET %%x)
SET /a z=(14-100%Month%%%100)/12, y=10000%Year%%%10000-z
SET /a ut=y*365+y/4-y/100+y/400+(153*(100%Month%%%100+12*z-3)+2)/5+%Day%-719469
SET /a ut=ut*86400+100%Hour%%%100*3600+100%Minute%%%100*60+100%Second%%%100
ENDLOCAL & SET %1=%ut%
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GetMachineGuid machineGuid
:: Extracting MachineGuid from the registry
SETLOCAL
FOR /f "tokens=2,*" %%x in ('reg query "HKLM\SOFTWARE\Microsoft\Cryptography" /v MachineGuid ^| findstr MachineGuid') DO SET mguid=%%y
ENDLOCAL & SET %1=%mguid%
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Log
:: Logging the function argument to file specified as logfile variable in the calling script
SETLOCAL
CALL :GetCurrentDate date
CALL :GetCurrentTime time
ECHO (%date% %time%) %1 >> %logfile%
ENDLOCAL
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckConsole
:: Checking whether 32 bits console was not used on 64 bits system
SETLOCAL
IF NOT "%ProgramFiles(x86)%"=="" (
	IF "%ProgramFiles(x86)%"=="%ProgramFiles%" (
		ENDLOCAL
		EXIT /B 129
		)
	)
ENDLOCAL
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckPermissions
:: Checking UAC elevation
SETLOCAL
NET FILE 1>NUL 2>NUL
SET rc=%ERRORLEVEL%
IF %rc% NEQ 0 ( 
	ECHO The requested operation requires administrative privileges and elevation
	ENDLOCAL
	EXIT /B 1 
	)
ENDLOCAL
EXIT /B 0

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckIsoTag
:: Checking correct ISO tag placement
SETLOCAL

FOR /R "%~dp0..\iso-swid\" %%f IN (*.swidtag) DO IF NOT "%%~nxf" == "ibm.com_IBM_BigFix_Inventory_RVU-9.2.16.0.swidtag" DEL /Q "%%f"	

IF NOT EXIST  "%~dp0..\iso-swid\ibm.com_IBM_BigFix_Inventory_RVU-9.2.16.0.swidtag" (
	ECHO Disconnected Scanner not properly extracted: ISO Tag file iso-swid\ibm.com_IBM_BigFix_Inventory_RVU-9.2.16.0.swidtag not found.
	EXIT /B 1
	)

ENDLOCAL
EXIT /B 0
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::