Set args = Wscript.Arguments
Set functionName = GetRef(args(0))
Call functionName 

' The first argument of this subroutine is the hardware scan output, the second is computer.yml file
Sub PrepareComputerYML
	Set hwScan = CreateObject("Microsoft.XMLDOM")
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Set shell = CreateObject("WSCript.shell")
	Set computerYml = objFSO.CreateTextFile(args(2),True)
	Set endpointID_file = objFSO.OpenTextFile(args(3), 1)
	Dim endpointID, computerName
	On Error Resume Next
	endpointID = endpointID_file.Readline
	If IsEmpty(endpointID) OR IsNull(endpointID) Then
			WScript.Quit 1
	End If
	computerName = shell.ExpandEnvironmentStrings( "%COMPUTERNAME%" )
	hwScan.Async = "False"
	hwScan.Load(args(1))
		
	computerYml.Write "endpointID: " & endpointID & vbCrLf
	computerYml.Write "Agent Version: windows 9.2.16.0-20190827-1723" & vbCrLf
	computerYml.Write "Catalog Version: 0.0" & vbCrLf
	computerYml.Write "Computer Name: " & computerName & vbCrLf
	
	Set operatingSystem=hwScan.selectNodes("//OperatingSystem/Type")
	For Each objNode in operatingSystem
		computerYml.Write "Operating System: " & objNode.Text & vbCrLf
	Next
	
	Dim lineCounter
	Set dnsName=hwScan.selectNodes("//IPAddress/Hostname")
	lineCounter=0
	For Each objNode in dnsName
		If lineCounter=0 Then
			computerYml.Write "DNS Name: " & objNode.Text & vbCrLf	
		Else
			computerYml.Write " " & objNode.Text & vbCrLf	
		End If
		lineCounter = lineCounter+1
	Next
	
	Set ipAddress=hwScan.selectNodes("//IPAddress/Address")
	lineCounter=0
	For Each objNode in ipAddress
		If lineCounter=0 Then
			computerYml.Write "IP Address: " & objNode.Text & vbCrLf
		Else
			computerYml.Write " " & objNode.Text & vbCrLf
		End If
		lineCounter = lineCounter+1
	Next
	
	computerYml.Close
End Sub

' The first argument of this subroutine is the catalog file, the second is computer.yml file
Sub UpdateCatalogVersion
	'Reading the first comment from catalog xml
	Set catalog = CreateObject("Microsoft.XMLDOM")
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	catalog.Async = "False"
	catalog.Load(args(1))
	Set catalogVersion = catalog.SelectSingleNode("//comment()[0]")
	catalogVersion = Split(catalogVersion.Text,":")(1)
	computerYmlPath = args(2)
	computerYmlTmpPath = args(2)&".tmp"
	Set computerYml = objFSO.OpenTextFile(computerYmlPath, 1, True)
	Set computerYmlTmp = objFSO.CreateTextFile(computerYmlTmpPath, 2)
	Do While Not computerYml.AtEndofStream
		line = computerYml.ReadLine
		If InStr(line, "Catalog Version:") Then
			line = "Catalog Version: " & catalogVersion
		End If
		If InStr(line, "Agent Version:") Then
			line = "Agent Version: windows 9.2.16.0-20190827-1723" 
		End If
		
		computerYmlTmp.WriteLine line
	Loop
	computerYml.Close
	computerYmlTmp.Close
	objFSO.DeleteFile(computerYmlPath)
	objFSO.MoveFile computerYmlTmpPath, computerYmlPath
End Sub

' The first argument of this subroutine is the catalog file, the second is fs_config.xml file
Sub UpdateFileExtensions
	'Reading the third comment from catalog xml
	Set catalog = CreateObject("Microsoft.XMLDOM")
	catalog.Async = "False"
	catalog.Load(args(1))
	Set fileExtensions = catalog.SelectSingleNode("//comment()[2]")
	fileExtensions = Replace(fileExtensions.Text," ", "")
	fileExtensions = Replace(fileExtensions,"Extensions:","")
	fileExtensions = Split(fileExtensions,";")
	' Remove last empty element
	Redim Preserve fileExtensions (UBound(fileExtensions) - 1)
	
	'Updating the fs_config.xml
	Set fsConfig = CreateObject("Microsoft.XMLDOM")
	fsConfig.Async = "False"
	fsConfig.Load(args(2))
	fsConfig.SelectNodes("//IBM/CIT/FSScan/FileMask").RemoveAll
	'The order in fs_config.xml has to be maintained
	Set ageNode = fsConfig.SelectSingleNode("//IBM/CIT/FSScan/Age")
	
	For Each i in fileExtensions 
		Set newEle = fsConfig.createElement("FileMask")
		Set value = fsConfig.CreateAttribute("value")	
		value.Value = i
		newEle.attributes.setNamedItem(value)
		fsConfig.SelectSingleNode("//IBM/CIT/FSScan").insertBefore newEle,ageNode 
	Next
		
	fsConfig.Save(args(2))
End Sub